Package ec.vector

# Class Gene

java.lang.Object
ec.vector.Gene

All Implemented Interfaces:
  `Prototype`, `Setup`, `Serializable`, `Cloneable`

Direct Known Subclasses:
  `NEATGene`

public abstract class Gene extends Object implements Prototype
Gene is an abstract superclass of objects which may be used in the genome array of GeneVectorIndividuals.

In addition to serialization for checkpointing, Genes may read and write themselves to streams in three ways.

- writeGene(...,DataOutput)/readGene(...,DataInput) This method transmits or receives a Gene in binary. It is the most efficient approach to sending Genes over networks, etc. The default versions of writeGene/readGene throw errors. You don't need to implement them if you don't plan on using read/writeGene.
- printGene(...,PrintWriter)/readGene(...,LineNumberReader) This approach transmits or receives a Gene in text encoded such that the Gene is largely readable by humans but can be read back in 100% by ECJ as well. To do this, these methods will typically encode numbers using the `ec.util.Code` class. These methods are mostly used to write out populations to files for inspection, slight modification, then reading back in later on. readGene reads in a line, then calls readGeneFromString on that line. You are responsible for implementing readGeneFromString: the Code class is there to help you. The default version throws an error if called. printGene calls printGeneToString and printlns the resultant string. You are responsible for implementing the printGeneToString method in such a way that readGeneFromString can read back in the Gene println'd with printGeneToString. The default form of printGeneToString() simply calls toString() by default. You might override printGeneToString() to provide better information. You are not required to implement these methods, but without them you will not be able to write Genes to files in a simultaneously computer- and human-readable fashion.
- printGeneForHumans(...,PrintWriter) This approach prints a Gene in a fashion intended for human consumption only. printGeneForHumans calls printGeneToStringForHumans() and printlns the resultant string. The default form of this method just returns the value of toString(). You may wish to override this to provide more information instead. You should handle one of these methods properly to ensure Genes can be printed by ECJ.

Default Base
vector.gene

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `P_GENE`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Gene()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Object`
  `clone()`
  Creates a new individual cloned from a prototype, and suitable to begin use in its own evolutionary context.
  `Parameter`
  `defaultBase()`
  Returns the default base for this prototype.
  `abstract boolean`
  `equals(Object other)`
  Unlike the standard form for Java, this function should return true if this gene is "genetically identical" to the other gene.
  `abstract int`
  `hashCode()`
  Generates a hash code for this gene -- the rule for this is that the hash code must be the same for two genes that are equal to each other genetically.
  `void`
  `mutate(EvolutionState state, int thread)`
  Mutate the gene.
  `void`
  `printGene(EvolutionState state, int verbosity, int log)`
  Prints the gene in a way that can be read by readGene().
  `void`
  `printGene(EvolutionState state, PrintWriter writer)`
  Prints the gene in a way that can be read by readGene().
  `void`
  `printGeneForHumans(EvolutionState state, int verbosity, int log)`
  Nice printing.
  `String`
  `printGeneToString()`
  Prints the gene to a string in a fashion readable by readGeneFromString and parseable by readGene(state, reader).
  `String`
  `printGeneToStringForHumans()`
  Prints the gene to a string in a human-readable fashion.
  `void`
  `readGene(EvolutionState state, DataInput dataInput)`
  Override this if you need to read rules in from a binary stream
  `void`
  `readGene(EvolutionState state, LineNumberReader reader)`
  Reads a gene printed by printGene(...).
  `void`
  `readGeneFromString(String string, EvolutionState state)`
  Reads a gene from a string, which may contain a final '\n'.
  `abstract void`
  `reset(EvolutionState state, int thread)`
  The reset method randomly reinitializes the gene.
  `void`
  `setup(EvolutionState state, Parameter base)`
  Sets up the object by reading it from the parameters stored in state, built off of the parameter base base.
  `void`
  `writeGene(EvolutionState state, DataOutput dataOutput)`
  Override this if you need to write rules out to a binary stream

  ### Methods inherited from class java.lang.Object

  `finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### P_GENE

    public static final String P_GENE
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### Gene

    public Gene()

- ## Method Details

  - ### setup

    public void setup(EvolutionState state, Parameter base)
    Description copied from interface: `Prototype`
    Sets up the object by reading it from the parameters stored in state, built off of the parameter base base. If an ancestor implements this method, be sure to call super.setup(state,base); before you do anything else.

    For prototypes, setup(...) is typically called once for the prototype instance; cloned instances do not receive the setup(...) call. setup(...) may be called more than once; the only guarantee is that it will get called at least once on an instance or some "parent" object from which it was ultimately cloned.

    Specified by:
      `setup` in interface `Prototype`
    Specified by:
      `setup` in interface `Setup`

  - ### defaultBase

    public Parameter defaultBase()
    Description copied from interface: `Prototype`
    Returns the default base for this prototype. This should generally be implemented by building off of the static base() method on the DefaultsForm object for the prototype's package. This should be callable during setup(...).
    Specified by:
      `defaultBase` in interface `Prototype`

  - ### clone

    public Object clone()
    Description copied from interface: `Prototype`
    Creates a new individual cloned from a prototype, and suitable to begin use in its own evolutionary context.

    Typically this should be a full "deep" clone. However, you may share certain elements with other objects rather than clone hem, depending on the situation:

    - If you hold objects which are shared with other instances, don't clone them.
    - If you hold objects which must be unique, clone them.
    - If you hold objects which were given to you as a gesture of kindness, and aren't owned by you, you probably shouldn't clone them.
    - DON'T attempt to clone: Singletons, Cliques, or Populations, or Subpopulation.
    - Arrays are not cloned automatically; you may need to clone an array if you're not sharing it with other instances. Arrays have the nice feature of being copyable by calling clone() on them.

    Implementations.

    - If no ancestor of yours implements clone(), and you have no need to do clone deeply, and you are abstract, then you should not declare clone().
    - If no ancestor of yours implements clone(), and you have no need to do clone deeply, and you are not abstract, then you should implement it as follows:

      ``

           public Object clone()
               {
               try
                   {
                   return super.clone();
                   }
               catch ((CloneNotSupportedException e)
                   { throw new InternalError(); } // never happens
               }

    - If no ancestor of yours implements clone(), but you need to deep-clone some things, then you should implement it as follows:

      ``

           public Object clone()
               {
               try
                   {
                   MyObject myobj = (MyObject) (super.clone());

                   // put your deep-cloning code here...
                   }
               catch ((CloneNotSupportedException e)
                   { throw new InternalError(); } // never happens
               return myobj;
               }

    - If an ancestor has implemented clone(), and you also need to deep clone some things, then you should implement it as follows:

      ``

           public Object clone()
               {
               MyObject myobj = (MyObject) (super.clone());

               // put your deep-cloning code here...

               return myobj;
               }

    Specified by:
      `clone` in interface `Prototype`
    Overrides:
      `clone` in class `Object`

  - ### hashCode

    public abstract int hashCode()
    Generates a hash code for this gene -- the rule for this is that the hash code must be the same for two genes that are equal to each other genetically.
    Overrides:
      `hashCode` in class `Object`

  - ### equals

    public abstract boolean equals(Object other)
    Unlike the standard form for Java, this function should return true if this gene is "genetically identical" to the other gene.
    Overrides:
      `equals` in class `Object`

  - ### reset

    public abstract void reset(EvolutionState state, int thread)
    The reset method randomly reinitializes the gene.

  - ### mutate

    public void mutate(EvolutionState state, int thread)
    Mutate the gene. The default form just resets the gene.

  - ### printGeneForHumans

    public void printGeneForHumans(EvolutionState state, int verbosity, int log)
    Nice printing. The default form simply calls printGeneToStringForHumans and prints the result, but you might want to override this.

  - ### printGeneToStringForHumans

    public String printGeneToStringForHumans()
    Prints the gene to a string in a human-readable fashion. The default simply calls toString().

  - ### printGeneToString

    public String printGeneToString()
    Prints the gene to a string in a fashion readable by readGeneFromString and parseable by readGene(state, reader). Override this. The default form returns toString().

  - ### readGeneFromString

    public void readGeneFromString(String string, EvolutionState state)
    Reads a gene from a string, which may contain a final '\n'. Override this method. The default form generates an error.

  - ### printGene

    public void printGene(EvolutionState state, int verbosity, int log)
    Prints the gene in a way that can be read by readGene(). The default form simply calls printGeneToString(). Override this gene to do custom writing to the log, or just override printGeneToString(...), which is probably easier to do.

  - ### printGene

    public void printGene(EvolutionState state, PrintWriter writer)
    Prints the gene in a way that can be read by readGene(). The default form simply calls printGeneToString(state). Override this gene to do custom writing, or just override printGeneToString(...), which is probably easier to do.

  - ### readGene

    public void readGene(EvolutionState state, LineNumberReader reader) throws IOException
    Reads a gene printed by printGene(...). The default form simply reads a line into a string, and then calls readGeneFromString() on that line. Override this gene to do custom reading, or just override readGeneFromString(...), which is probably easier to do.
    Throws:
      `IOException`

  - ### writeGene

    public void writeGene(EvolutionState state, DataOutput dataOutput) throws IOException
    Override this if you need to write rules out to a binary stream
    Throws:
      `IOException`

  - ### readGene

    public void readGene(EvolutionState state, DataInput dataInput) throws IOException
    Override this if you need to read rules in from a binary stream
    Throws:
      `IOException`